import java.util.*;

public class TestCollection {

	public static void main(String argv[]) {
		
		// création d'un ensemble trié de points

//		Set coll = new TreeSet();
//		Point2D p1 = new Point2DArray(5, 4);
//		coll.add(p1);
//
//		Point2D p2 = new Point2DArray(8, 4);
//		coll.add(p2);
//
//		Point2D p3 = new Point2DXY(7, 4);
//		coll.add(p3);
//
//		System.out.println(coll);

		  // on peut modifier un élément de l'ensemble :
	      // l'unicité n'est plus garantie
	      // p3.setX(5);
	      // System.out.println(coll);
	      
		
		// création d'un ensemble trié de Point , coordonnées aléatoires
		
		Random gen = new Random();
		
		Set coll = new TreeSet();
		for (int i=0; i<100; ++i){
			int x = gen.nextInt(100);
			int y = gen.nextInt(100);
			Point2D p = new Point2DArray(x, y);
			coll.add(p);
		}
		
		System.out.println(coll);
	    
		// translation appliquée à chaque point de l'ensemble
		Iterator it = coll.iterator();
		while (it.hasNext()){
			Point2D p = (Point2D) it.next();
			p.translate(-50, -50);
		}
		System.out.println(coll);
		
		// sélection des points d'un disque
		it = coll.iterator();
		Set selection = new TreeSet(); 
		while (it.hasNext()){
			Point2D p = (Point2D) it.next();
			double x = p.getX();
			double y = p.getY();
			if ( (x-10)*(x-10)+(y-10)*(y-10) < 25 )
				selection.add(p);
		}
		System.out.println(selection);
		
	}
}
